/* ex12-10.c         une structure est une "l-value"
       qui permet une affectation sur structures de même type
       et d'être en retour d'une fonction.
*/

#include <stdio.h>

struct typeEss
 {
 char chChar;
 int chInt;
 float chFlo;
 };

struct typeEss fctr( struct typeEss pass, struct typeEss add )
 {
 struct typeEss retour;
 retour.chChar = pass.chChar + add.chChar;
 retour.chInt = pass.chInt + add.chInt;
 retour.chFlo = pass.chFlo + add.chFlo;
 return retour; //retourne un type structuré
 }


int main(void)
 {
 struct typeEss str_1 = {'a', 22 ,5.6};
 printf("structure initiale : chChar=%c -- chInt=%d -- chFlo=%f \n", str_1.chChar
                   , str_1.chInt, str_1.chFlo);
 struct typeEss str_2 = {1, 1 ,1.1};
 struct typeEss str_3 =  str_1; //affectation sur structures de même type
 printf("structure copiée : chChar=%c -- chInt=%d -- chFlo=%f \n", str_3.chChar
                   , str_3.chInt, str_3.chFlo);
 //Appel de la fonction fctr() en lui passant des variables structurées....
 struct typeEss str_4 = fctr( str_3, str_2);
 printf("structure résultat: chChar=%c -- chInt=%d -- chFlo=%f \n", str_4.chChar
                   , str_4.chInt, str_4.chFlo);
 return 0;
 }

