/* ex14-3.c
        utilisation d'un tableau de pointeurs de fonctions
          cette fois avec typedef
*/

#include <stdio.h>

int main(void)
 {
 char oper;
 unsigned index=10;
 int prEnt, dxmEnt;
 int fctPlus (int prArg, int dxmArg); // +
 int fctMult (int prArg, int dxmArg); // x
 int fctDiv (int prArg, int dxmArg);  // /
 int fctMod (int prArg, int dxmArg);  // %
 typedef int (* PtOperfct)(int, int ); //définition d'un type pointeur ...
 //qui simplifie la déclaration du tableau
 PtOperfct tabOper[4] = {fctPlus, fctMult, fctDiv, fctMod};
 printf("entrez le type d'opération: + , x, / , %%\n");//"échappement" de % !!!
 scanf("%c", &oper);
 switch (oper)
  {
  case '+':
   index =0;
   printf("opérateur choisi : addition\n");
   break;
  case 'x':
   index =1;
   printf("opérateur choisi : multiplication\n");
   break;
  case '/':
   index =2;
   printf("opérateur choisi : division\n");
   break;
  case '%':
   index =3;
   printf("opérateur choisi : modulo\n");
   break;
  default :
   printf("opérateur inconnu ?\n");
   return 0;
  }
 printf("entrez le 1er entier\n");
 scanf("%d", &prEnt);
 printf("entrez le 2eme entier\n");
 scanf("%d", &dxmEnt);
 printf("vous avez entré %d ...%d ", prEnt, dxmEnt);
 printf("le résultat est : %d\n", tabOper[index](prEnt, dxmEnt));
 // ou (2eme possibilité)
 //printf("le résultat est : %d\n", (* tabOper[index])(prEnt, dxmEnt));
 return 0;
 }

// --------- définition des fonctions
int fctPlus (int prArg, int dxmArg)
 {
 return (prArg + dxmArg);
 }

int fctMult (int prArg, int dxmArg)
 {
 return (prArg * dxmArg);
 }

int fctDiv (int prArg, int dxmArg)
 {
 return (prArg / dxmArg);
 }

int fctMod (int prArg, int dxmArg)
 {
 return (prArg % dxmArg);
 }

